use super::schema::member_permissions;
use beteran_common_rust as bcr;

///
#[derive(Eq, Hash, Identifiable, Queryable, PartialEq, Debug, Clone)]
#[table_name = "member_permissions"]
#[primary_key(member_id, role_resource_action_id)]
pub struct MemberPermission {
  ///
  pub member_id: uuid::Uuid,
  ///
  pub role_resource_action_id: uuid::Uuid,
  ///
  pub created_at: i64,
}

///
#[derive(Insertable, Debug, Clone)]
#[table_name = "member_permissions"]
pub struct NewMemberPermission {
  ///
  pub member_id: uuid::Uuid,
  ///
  pub role_resource_action_id: uuid::Uuid,
}

///
#[derive(Debug, Clone)]
pub struct FindAllSearch {
  ///
  pub role_resource_action_id: Option<uuid::Uuid>,
  ///
  pub member_id: Option<uuid::Uuid>,
}

///
#[derive(Debug, Clone)]
pub struct FindAll {
  ///
  pub search: Option<FindAllSearch>,
  ///
  pub pagination: Option<bcr::pagination::Pagination>,
  ///
  pub sorts: Option<Vec<bcr::pagination::Sort>>,
}
